#
# NOSOUND driver for sega mega drive
# Copyright(c) 2023 Emmanuel Rousseau;
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files(the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and / or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all; copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
#

import os
from typing import List
import logging


class Compression:
    AUTO = "AUTO"
    NONE = "NONE"
    APLIB = "APLIB"
    LZ4W = "LZ4W"
    BEST = "BEST"


class Optimization:
    NONE = "NONE"
    ALL = "ALL"
    DUPLICATE = "DUPLICATE"
    BALANCED = "BALANCED"
    SPRITE = "SPRITE"
    TILE = "TILE"


class Collision:
    CIRCLE = "CIRCLE"
    BOX = "BOX"
    NONE = "NONE"


class Rescomp:
    def __init__(self, res_filepath: str):
        self.res_filepath: str = res_filepath
        self.lines: List[str] = ["# this file is autogenerated, do not manually edit"]

    def palette(self, cname: str, filepath: str, comment: str = ""):
        """
        PALETTE
        -------
        Take a .pal file or an image as input and transform it in SGDK Palette structure.
        If the input image is 1 pixel heigth then the width is the palette size and pixel X represent color data at index X.
        In others cases the usual image palette data is used instead.

        Palette is used as color input for Bitmap, Image and Sprite resources.

        Syntax:
        PALETTE name file

            name            name of the output Bitmap structure
            file            path of the input image file (should be 8bpp .bmp or .png) or .pal file

        """
        res_path: str = os.path.dirname(self.res_filepath)
        filepath = os.path.relpath(filepath, res_path)
        if comment:
            self.lines.append(f"# {comment}")
        l: str = f"PALETTE {cname} {filepath}"
        self.lines.append(l.strip())

    def sprite(
        self,
        cname: str,
        img_filepath: str,
        cell_w: int,
        cell_h: int,
        compression: str = Compression.NONE,
        time: int = 0,
        collision: str = Collision.NONE,
        optimization: str = Optimization.BALANCED,
        iteration: int = -1,
        comment: str = "",
    ):
        """
        SPRITE
        ------
        Take an image as input and transform it in SGDK SpriteDefinition structure.
        SpriteDefinition is used to draw, animate and manage sprites, it internally contains severals TileSet, Palette and Animation structures.

        Syntax:
        SPRITE name img_file width heigth [compression [time [collision [opt [iteration]]]]]

            name            name of the output SpriteDefinition structure
            img_file        path of the input image file (should be indexed colors image in .bmp or .png format)
            width           width of a single sprite frame in tile (should be < 32)
            heigth          heigth of a single sprite frame in tile (should be < 32)
            compression     compression type, accepted values:
                            -1 / BEST / AUTO = use best compression
                                0 / NONE        = no compression (default)
                                1 / APLIB       = aplib library (good compression ratio but slow, don't use it for streamed sprite)
                                2 / FAST / LZ4W = custom lz4 compression (average compression ratio but fast, recommended for streamed sprite)
            time            display frame time in 1/60 of second (time between each animation frame)
                            If this value is set to 0 (default) then auto animation is disabled
            collision       collision type: CIRCLE, BOX or NONE (NONE by default)
            opt             sprite cutting optimization strategy, accepted values:
                                0 / BALANCED  = balance between used tiles and hardware sprites (default)
                                1 / SPRITE    = reduce the number of hardware sprite (using bigger sprite) at the expense of more used tiles
                                2 / TILE      = reduce the number of tiles at the expense of more hardware sprite (using smaller sprite)
                                3 / NONE      = no optimization (cover the whole sprite frame)
            iteration       number of iteration for sprite cutting optimization (default = 500000)

        Some informations about how SpriteDefinition is generated from the input image:
        - input image dimension should be aligned on tile (multiple of 8).
        - input image is a grid where each cell represents a single animation frame and where each row define a complete sprite animation.
        - an animation cannot contains more than 255 frames.
        - cell size (frame size) = width * height (in tile) where width and height should be < 32 (maximum = 248 pixels for both width and height).
        - a frame can be composed of several internal VDP (hardware) sprites but it stricly limited to a maximum of 16 hardware sprites.
        If the sprite is too large to fit in 16 hardware sprites (rescomp will complain about it), then you may reduce its size or split it in 2 parts.
        - rescomp detects flipped frame to avoid redundant sprite tiles.
        - rescomp detects empty frame at end of animation row to not store empty frame data.
        - rescomp try to optimize hardware sprites and vRAM usage by detecting empty areas in sprite frames.
        - rescomp detects frame copy inside an animation to generate the according animation sequence.
        - by default collision bounds are calculated by using 75% of the original sprite frame.
        """
        print(img_filepath)

        if compression not in [Compression.NONE, Compression.APLIB, Compression.LZ4W]:
            raise RescompError(f"compression scheme '{compression}' invalid for SPRITE")
        if optimization not in [
            Optimization.NONE,
            Optimization.TILE,
            Optimization.SPRITE,
            Optimization.BALANCED,
        ]:
            raise RescompError(
                f"optimization scheme '{optimization}' invalid for SPRITE"
            )

        res_path: str = os.path.dirname(self.res_filepath)
        img_filepath = os.path.relpath(img_filepath, res_path)

        if cell_w >= 32 or cell_h >= 32:
            raise RescompError(f"maximum dimension for SPRITE {cname} is 31x31 cells")

        if cell_w < 1 or cell_h < 1:
            raise RescompError(f"minimum dimension for SPRITE {cname} is 1x1 cells")

        if time < 0:
            raise RescompError(f"minimum time is 0 for SPRITE {cname}")

        if iteration == -1:
            iteration = ""

        if comment:
            self.lines.append(f"# {comment}")
        l: str = f"SPRITE {cname} {img_filepath} {cell_w} {cell_h} {compression} {time} {collision} {optimization} {iteration}"
        self.lines.append(l.strip())

    def binary(
        self,
        cname: str,
        filepath: str,
        align: int = 2,
        salign: int = 2,
        fill: int = 0,
        compression: str = Compression.NONE,
        far: bool = True,
        comment: str = "",
    ):
        """
        name            BIN data variable name
        file            path of the data file to convert to binary data array
        align           memory address alignment for generated data array (default is 2)
        salign          size alignment for the generated data array (default is 2)
        fill            fill value for the size alignment (default is 0)
        compression     compression type, accepted values:
                            0 / NONE        = no compression
                            1 / APLIB       = aplib library (good compression ratio but slow)
                            2 / FAST / LZ4W = custom lz4 compression (average compression ratio but fast)
        far             'far' binary data flag to put it at the end of the ROM (useful for bank switch, default = TRUE)"""

        if compression not in [Compression.NONE, Compression.APLIB, Compression.LZ4W]:
            raise RescompError(f"compression scheme '{compression}' invalid for SPRITE")

        res_path: str = os.path.dirname(self.res_filepath)
        filepath = os.path.relpath(filepath, res_path)

        if comment:
            self.lines.append(f"# {comment}")

        far_str = f"{far}".upper()
        l: str = (
            f"BIN {cname} {filepath} {align} {salign} {fill} {compression} {far_str}"
        )
        self.lines.append(l.strip())

    def tileset(
        self,
        cname: str,
        img_filepath: str,
        compression: str = Compression.AUTO,
        optimization: str = Optimization.ALL,
        comment: str = "",
    ):
        """
        TILESET
        -------
        Take an image as input and transform it in SGDK TileSet structure.
        TileSet is used as tiles source for Image and Sprite.

        Syntax:
        TILESET name img_file [compression [opt]]

            name            name of the output TileSet structure
            img_file        path of the input image file (should be 8bpp .bmp or .png)
            compression     compression type (use unpackTileSet(..) to unpack), accepted values:
                            -1 / BEST / AUTO = use best compression
                                0 / NONE        = no compression (default)
                                1 / APLIB       = aplib library (good compression ratio but slow)
                                2 / FAST / LZ4W = custom lz4 compression (average compression ratio but fast)
            opt             define the optimisation level, accepted values:
                                0 / NONE        = no optimisation, each tile is unique
                                1 / ALL         = ignore duplicated and flipped tile (default)
                                2 / DUPLICATE   = ignore duplicated tile only
        """
        if compression not in [
            Compression.NONE,
            Compression.BEST,
            Compression.APLIB,
            Compression.LZ4W,
        ]:
            raise RescompError(
                f"compression scheme '{compression}' invalid for TILESET"
            )
        if optimization not in [
            Optimization.NONE,
            Optimization.ALL,
            Optimization.DUPLICATE,
        ]:
            raise RescompError(
                f"optimization scheme '{optimization}' invalid for TILESET"
            )

        res_path: str = os.path.dirname(self.res_filepath)
        img_filepath = os.path.relpath(img_filepath, res_path)

        if comment:
            self.line.append(f"# {comment}")

        l: str = f"TILESET {cname} {img_filepath} {compression} {optimization}"
        self.lines.append(l)

    def write(self):
        with open(self.res_filepath, "w") as f:
            logging.info(f"Write {self.res_filepath}")
            for l in self.lines:
                f.write(f"{l}\n")


class RescompError(RuntimeError):
    pass
